"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.handler = exports.logFeedbackNudge = exports.feedback = exports.builder = exports.desc = exports.command = void 0;
const chalk_1 = __importDefault(require("chalk"));
const open_1 = __importDefault(require("open"));
const async_1 = require("../utils/async");
exports.command = 'feedback';
exports.desc = 'Send feedback to Contentful';
const builder = (yargs) => yargs
    .usage('Usage: contentful feedback')
    .epilog([
    "We'd love to hear from you! Check out our five question developer experience survey at:",
    'https://87dc93gvoy0.typeform.com/to/d1RgWfZX'
].join('\n'));
exports.builder = builder;
const feedback = () => __awaiter(void 0, void 0, void 0, function* () {
    (0, open_1.default)('https://87dc93gvoy0.typeform.com/to/d1RgWfZX');
});
exports.feedback = feedback;
function logFeedbackNudge() {
    console.log(`Have any feedback for the ${chalk_1.default.blue('Conte')}${chalk_1.default.yellow('ntful')}${chalk_1.default.red(' CLI')}? We'd love to hear from you! Check out our five question developer experience survey at:
  ${chalk_1.default.underline('https://87dc93gvoy0.typeform.com/to/d1RgWfZX')}
  `);
}
exports.logFeedbackNudge = logFeedbackNudge;
exports.handler = (0, async_1.handleAsyncError)(exports.feedback);
