"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const uuid_1 = require("uuid");
/**
 * Adds a sequence header to a header object
 * @param {object} headers
 */
// TODO: next major release (v9.0.0+) - change this to a non-default export.
function addSequenceHeader(headers) {
    if (typeof headers !== 'object')
        throw new Error('addSequence function expects an object as input');
    return {
        ...headers,
        // Unique sequence header
        'CF-Sequence': (0, uuid_1.v4)()
    };
}
exports.default = addSequenceHeader;
