import type { AxiosStatic } from 'axios';
import type { AxiosInstance, CreateHttpClientParams } from './types';
/**
 * Create pre-configured axios instance
 * @private
 * @param {AxiosStatic} axios - Axios library
 * @param {CreateHttpClientParams} options - Initialization parameters for the HTTP client
 * @return {AxiosInstance} Initialized axios instance
 */
export default function createHttpClient(axios: AxiosStatic, options: CreateHttpClientParams): AxiosInstance;
